import React from 'react';
import { Strings } from '../constants/strings';
export declare const StyledBuilder: import("styled-components").StyledComponent<"div", any, {}, never>;
export declare type BuilderFieldType = 'BOOLEAN' | 'TEXT' | 'DATE' | 'NUMBER' | 'STATEMENT' | 'LIST' | 'MULTI_LIST' | 'GROUP';
export declare type BuilderFieldOperator = 'LARGER' | 'SMALLER' | 'LARGER_EQUAL' | 'SMALLER_EQUAL' | 'EQUAL' | 'NOT_EQUAL' | 'ALL_IN' | 'ANY_IN' | 'NOT_IN' | 'BETWEEN' | 'NOT_BETWEEN';
export declare type BuilderGroupValues = 'AND' | 'OR';
export interface BuilderFieldProps {
    field: string;
    label: string;
    value?: React.ReactText | React.ReactText[] | boolean | {
        value: React.ReactText;
        label: string;
    }[];
    type: BuilderFieldType;
    operators?: BuilderFieldOperator[];
}
export interface BuilderComponentsProps {
    form?: {
        Select?: any;
        SelectMulti?: any;
        Switch?: any;
        Input?: any;
    };
    Remove?: any;
    Add?: any;
    Component?: any;
    Group?: any;
    GroupHeaderOption?: any;
}
export interface BuilderProps {
    fields: BuilderFieldProps[];
    data: any;
    components?: BuilderComponentsProps;
    strings?: Strings;
    onChange?: (data: any) => any;
}
export interface BuilderContextProps {
    fields: BuilderFieldProps[];
    data: any;
    components: BuilderComponentsProps;
    strings: Strings;
    setData: React.Dispatch<any>;
    onChange: (data: any) => void;
}
export declare const BuilderContext: React.Context<BuilderContextProps>;
export declare const defaultComponents: BuilderComponentsProps;
export declare const Builder: React.FC<BuilderProps>;
